## aqsis 1.8.2

=== CMakeLists.txt ===
project(aqsis_all)

cmake_minimum_required(VERSION 2.6.3)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)

# Disallow in-source build
string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" aqsis_in_source)
if(aqsis_in_source)
	message(FATAL_ERROR "Aqsis requires an out of source build.  Please clean any cmake-generated files from the source directory, create a separate build directory and run 'cmake path_to_source [options]' there.")
endif()


# Path to aqsis-specific include directories for cmake helper scripts.
set(CMAKE_MODULE_PATH
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules"
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# Include some helper scripts and macros.
include(UtilMacros)
include(AqsisTesting)
include(FirstCMakeRun)

#-------------------------------------------------------------------------------
# Build-time options which can be set from ccmake or the command line
#--------------------------------------------------------------------

option(AQSIS_USE_TIMERS "Enable performance timers" ON)
option(AQSIS_USE_PDIFF "Build the external pdiff perceptual image difference utility" OFF)
option(AQSIS_USE_QT "Build the aqsis GUI components which rely on the Qt libraries" ON)
option(AQSIS_USE_OPENEXR "Build aqsis with support for the OpenEXR image format" ON)
option(AQSIS_USE_PNG "Build aqsis with support for reading PNG image files" ON)
option(AQSIS_USE_EXTERNAL_TINYXML "Try to find and use an external tinyxml library" OFF)
mark_as_advanced(AQSIS_USE_PDIFF AQSIS_USE_EXTERNAL_TINYXML)

option(aqsis_enable_testing "Enable unit testing" OFF)
option(AQSIS_ENABLE_MPDUMP "Enable micropolygon dumping code" OFF)
option(AQSIS_ENABLE_MASSIVE "Enable Massive support" ON)
option(AQSIS_ENABLE_SIMBIONT "Enable Simbiont(RM) support" ON)
option(AQSIS_ENABLE_THREADING "Enable multi-threading (EXPERIMENTAL)" OFF)
option(AQSIS_ENABLE_DOCS "Enable documentation generation" ON)
mark_as_advanced(AQSIS_ENABLE_MPDUMP AQSIS_ENABLE_MASSIVE AQSIS_ENABLE_SIMBIONT)

option(AQSIS_USE_RPATH "Enable runtime path for installed libs" ON)
mark_as_advanced(AQSIS_USE_RPATH)

if(WIN32)
	# Find path to precompiled libs on windows.
	set(AQSIS_WIN32LIBS "" CACHE PATH "The location of the win32libs SVN folder")
	if(MINGW)
		set(AQSIS_DEPENDENCIES "${CMAKE_SOURCE_DIR}/../dependencies" CACHE PATH "The location of the pre-built dependencies")
	endif()
endif()

set(AQSIS_MAIN_CONFIG_NAME "aqsisrc"
	CACHE STRING "Name of the main aqsis configuration file")
mark_as_advanced(AQSIS_MAIN_CONFIG_NAME)


#-------------------------------------------------------------------------------
# Find necessary library dependencies.
#-------------------------------------

# Required libs
# -------------
find_package(TIFF)
find_package(ZLIB)

# Find boost.
if(WIN32)
	set(BOOST_ROOT "${AQSIS_DEPENDENCIES}" CACHE PATH "Root location of the boost install")
  if(NOT MINGW)
    set(Boost_USE_STATIC_LIBS ON)
  endif()
else()
	set(BOOST_ROOT "$ENV{BOOST_ROOT}" CACHE PATH "Root location of the Boost install")
endif()
set(Boost_ADDITIONAL_VERSIONS "1.45.0" "1.45" "1.44.0" "1.44"
	"1.43.0" "1.43" "1.42.0" "1.42" "1.41.0" "1.41"
	"1.40.0" "1.40" "1.39.0" "1.39" "1.38.0" "1.38" "1.37.0" "1.37")
find_package(Boost 1.34.1)
# The following is a workaround because Boost versions > 1.35.0 need the
# system library. CMake versions >2.6.4 should fix this properly.
set(local_boost_version "${Boost_MAJOR_VERSION}.${Boost_MINOR_VERSION}")
if(local_boost_version VERSION_LESS "1.35")
    if(WIN32)
        find_package(Boost 1.34.1
		COMPONENTS filesystem iostreams wave unit_test_framework thread regex zlib program_options)
    else()
        find_package(Boost 1.34.1
		COMPONENTS filesystem iostreams wave unit_test_framework thread regex program_options)
    endif()
else()
    if(WIN32)
        find_package(Boost 1.34.1
		COMPONENTS filesystem iostreams wave unit_test_framework thread regex system zlib program_options)
    else()
        find_package(Boost 1.34.1
		COMPONENTS filesystem iostreams wave unit_test_framework thread regex system program_options)
    endif()
endif()

link_directories(${Boost_LIBRARY_DIRS})


# Optional libs
# -------------

# GUI libs
if(AQSIS_USE_QT)
	find_package(Qt4 4.6.2 COMPONENTS QtCore QtGui QtOpenGL)

	if(NOT QT_FOUND)
		message("** Qt4 not found - building without aqsis GUI tools")
		set(AQSIS_USE_QT OFF)
	endif()
endif()

# OpenEXR
if(AQSIS_USE_OPENEXR)
	find_package(OpenEXR)

	if(NOT AQSIS_OPENEXR_FOUND)
		message("** Cannot find OpenEXR - aqsis will be built without support for the OpenEXR image format")
		set(AQSIS_USE_OPENEXR OFF)
	endif()
endif()

if(AQSIS_USE_PNG)
	find_package(PNG)

	if(NOT AQSIS_PNG_FOUND)
		message("** Cannot find PNG - aqsis will be built without support for the PNG image format")
		set(AQSIS_USE_PNG OFF)
	endif()
endif()

## find tinyxml.  If not found we use the version distributed with the aqsis
## source.
#if(AQSIS_USE_EXTERNAL_TINYXML)
#	find_package(TinyXML)
#	if(NOT TINYXML_FOUND)
#		message("** Cannot find external tinyxml library - using version included with the aqsis source.")
#		set(AQSIS_USE_EXTERNAL_TINYXML OFF)
#	endif()
#endif()


#-------------------------------------------------------------------------------
# Find build tools
#-----------------

include(FindFlexBison)

if(NOT AQSIS_FLEX_EXECUTABLE_FOUND)
	message(FATAL_ERROR "Aqsis requires flex to build")
endif()
if(NOT AQSIS_BISON_EXECUTABLE_FOUND)
	message(FATAL_ERROR "Aqsis requires bison to build")
endif()

# Windows-specific build tools:
include(FindNSIS)
# Apple-specific build tools:
include(FindOsacompile)
include(FindXcodebuild)
include(FindResource)


#-------------------------------------------------------------------------------
# Find documentation tools
#-------------------------

if(AQSIS_ENABLE_DOCS)
	include(FindSphinx)

	find_package(Doxygen)

	if(NOT AQSIS_SPHINX_EXECUTABLE_FOUND)
                message("** Cannot find Sphinx - building without generating relevant documentation")
        endif()

	if(NOT DOXYGEN_FOUND)
		message("** Cannot find Doxygen - building without generating relevant documentation")
	endif()

	if(NOT AQSIS_SPHINX_EXECUTABLE_FOUND AND NOT DOXYGEN_FOUND)
		set(AQSIS_ENABLE_DOCS OFF)
	endif()
endif()


#-------------------------------------------------------------------------------
# Set program version numbers
#----------------------------

# These are needed by version.h, as well as the packaging stuff.  Note that
# some packaging variables are set in the platform-specific config files, and
# these version variables are potentially used there.
set(VERSION_MAJOR 1)
set(VERSION_MINOR 8)
set(VERSION_BUILD 2)
set(SCM_REVISION 0) # "?"


#-------------------------------------------------------------------------------
# Set variables which control the build
#--------------------------------------

# Set convenience locations into which libraries and executables will be
# placed during the build.  Note: This is irrelevant to the install.
set(RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
#set(ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)


# Set default build type the first time cmake is run, but only if it's empty
# since an alternative value might have been specified on the command line,
# and we want this to override the default given below.
#
# We need to jump through some hoops here with the set_if_empty() macro, since
# CMAKE_BUILD_TYPE is a system-defined variable which means we can't get to it
# with set() before it's defined.
if(FIRST_CMAKE_RUN)
	set_if_empty(CMAKE_BUILD_TYPE "Release" CACHE STRING
		"Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel."
		FORCE
		)
endif()

# Make sure that CMAKE_INSTALL_PREFIX is absolute.  If we don't do this, it
# seems that we get relative values for the RPATH (which making
# CMAKE_INSTALL_RPATH absolute doesn't help??), which results in broken
# binaries.
if(NOT IS_ABSOLUTE ${CMAKE_INSTALL_PREFIX})
	message(STATUS "Warning: CMAKE_INSTALL_PREFIX relative path interpreted relative to build directory location.")
	set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_PREFIX}")
endif()

# Set up the install rpath if desired.
set(CMAKE_SKIP_RPATH OFF CACHE INTERNAL
	"Disabled, since we need RPATHS to find aqsl during the build" FORCE)
if(AQSIS_USE_RPATH)
	set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIBDIR}")
endif()


#-------------------------------------------------------------------------------
# System-specific includes
#-------------------------

# Include setup for system-specific paths, packaging etc
if(WIN32)
	include(${CMAKE_SOURCE_DIR}/cmake/platform/windows.cmake)
	# Build the .rc files for library and executable version information and icons.
	set(INFORES_SRCS "${PROJECT_BINARY_DIR}/info.rc")
	set(ICONRES_SRCS "${PROJECT_BINARY_DIR}/icon.rc")
	configure_file("${CMAKE_SOURCE_DIR}/distribution/win/info.rc.in.cmake" ${INFORES_SRCS})
	configure_file("${CMAKE_SOURCE_DIR}/distribution/win/icon.rc.in.cmake" ${ICONRES_SRCS})
elseif(APPLE)
	include(${CMAKE_SOURCE_DIR}/cmake/platform/macosx.cmake)
else()
	include(${CMAKE_SOURCE_DIR}/cmake/platform/linux.cmake) 
endif()


#-------------------------------------------------------------------------------
# Add directories for all subprojects
#------------------------------------
add_subdirectory(include/aqsis)
include_directories(
	"${PROJECT_SOURCE_DIR}/include"
	"${PROJECT_BINARY_DIR}/include"
	${Boost_INCLUDE_DIRS}
)

# Thirdparty libs
declare_subproject(thirdparty/tinyxml)
declare_subproject(thirdparty/partio)
declare_subproject(libs/pointrender)
if(AQSIS_USE_PDIFF)
  add_subdirectory(thirdparty/pdiff)
endif()

# Build libraries
add_subdirectory(libs/math)
add_subdirectory(libs/util)
get_directory_property(aqsis_util_location DIRECTORY libs/util DEFINITION aqsis_util_location)
add_subdirectory(libs/riutil)
add_subdirectory(libs/slcomp)
get_directory_property(aqsis_slcomp_location DIRECTORY libs/slcomp DEFINITION aqsis_slcomp_location)
add_subdirectory(libs/tex)
add_subdirectory(libs/shadervm)
add_subdirectory(libs/slxargs)
add_subdirectory(libs/ri2rib)
add_subdirectory(libs/core)

# Build executable tools
add_subdirectory(tools/aqsl)
add_subdirectory(tools/aqsltell)
add_subdirectory(tools/aqsis)
add_subdirectory(tools/miqser)
add_subdirectory(tools/teqser)
if(AQSIS_USE_QT)
	add_subdirectory(tools/eqsl)
	add_subdirectory(tools/piqsl)
	add_subdirectory(tools/ptview)
endif()

# Build displays
add_subdirectory(tools/displays)

# Build additional plugins
add_subdirectory(tools/procedurals/hairgen)
#add_subdirectory(tools/shadeops/sci_volumes)
add_subdirectory(tools/neqsus)

# Build shaders & install examples
add_subdirectory(shaders)
add_subdirectory(examples)

# Build documentation
if(AQSIS_ENABLE_DOCS)
	add_subdirectory(doc)
endif()

# Packaging
add_subdirectory(distribution)

#-------------------------------------------------------------------------------
# Create aqsisrc
#--------------
get_directory_property(display_DISPLAYLIB DIRECTORY tools/displays DEFINITION file_display_name)
get_directory_property(d_exr_DISPLAYLIB DIRECTORY tools/displays DEFINITION exr_display_name)
get_directory_property(d_bmp_DISPLAYLIB DIRECTORY tools/displays DEFINITION bmp_display_name)
get_directory_property(d_xpm_DISPLAYLIB DIRECTORY tools/displays DEFINITION xpm_display_name)
get_directory_property(piqsl_DISPLAYLIB DIRECTORY tools/displays DEFINITION piqsl_display_name)
# Default search paths.
set(DEFAULT_SHADERPATH ${shader_search_path})
set(DEFAULT_ARCHIVEPATH "${CMAKE_INSTALL_PREFIX}")
set(DEFAULT_TEXTUREPATH "${CMAKE_INSTALL_PREFIX}")
set_with_path_prefix(DEFAULT_DISPLAYPATH "${PLUGINDIR}" "${CMAKE_INSTALL_PREFIX}")
set_with_path_prefix(DEFAULT_PROCEDURALPATH "${PLUGINDIR}" "${CMAKE_INSTALL_PREFIX}")
set(DEFAULT_RESOURCEPATH "${CMAKE_INSTALL_PREFIX}")
# Search paths which are settable from the cmake build.

=== doc/CMakeLists.txt ===
project(documentation)

#source_tree_relpath(docs_reldir)
#set(docs_install_dir ${share_install_dir}/${docs_reldir})
set(docs_install_dir ${DOCSDIR})

if(AQSIS_SPHINX_EXECUTABLE)
	add_custom_target(devguide make BUILDDIR="${PROJECT_BINARY_DIR}/guide/dev" html latexpdf
                WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}/guide/dev")
	add_custom_target(houdiniguide make BUILDDIR="${PROJECT_BINARY_DIR}/guide/houdini" html latexpdf
                WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}/guide/houdini")
	add_custom_target(usermanual make BUILDDIR="${PROJECT_BINARY_DIR}/manual/user" html latexpdf
		WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}/manual/user")
endif()

if(DOXYGEN_EXECUTABLE)
	configure_file("${PROJECT_SOURCE_DIR}/manual/dev/Doxyfile.in.cmake" "${PROJECT_BINARY_DIR}/manual/dev/Doxyfile" @ONLY)

	add_custom_target(devmanual ${DOXYGEN_EXECUTABLE}
		WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/manual/dev")
endif()

install(DIRECTORY ${PROJECT_BINARY_DIR}/guide/dev/latex/ ${PROJECT_BINARY_DIR}/guide/houdini/latex/ ${PROJECT_BINARY_DIR}/manual/dev/latex/ ${PROJECT_BINARY_DIR}/manual/user/latex/
	DESTINATION ${docs_install_dir}
	COMPONENT docs
	FILES_MATCHING PATTERN "*.pdf")

=== examples/CMakeLists.txt ===
project(example_content)

#source_tree_relpath(examples_reldir)
#set(examples_install_dir ${share_install_dir}/${examples_reldir})
set(examples_install_dir ${EXAMPLESDIR})

set(dirs_to_install
	features procedurals scenes point_based_gi)

if(WIN32)
	install(DIRECTORY ${dirs_to_install}
		DESTINATION ${examples_install_dir}
		COMPONENT examples
		# TODO: Refactor the blobby content examples to allow distribution.  For
		# now we exclude them with a pattern.
		PATTERN "features/blobby" EXCLUDE
		PATTERN "features/pointcloud" EXCLUDE
		PATTERN "*.sh" EXCLUDE)
else()
	install(DIRECTORY ${dirs_to_install}
		DESTINATION ${examples_install_dir}
		COMPONENT examples
		# TODO: Refactor the blobby content examples to allow distribution.  For
		# now we exclude them with a pattern.
		PATTERN "features/blobby" EXCLUDE
		PATTERN "features/pointcloud" EXCLUDE
		PATTERN "*.bat" EXCLUDE
		PATTERN "*.sh"
		PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
				GROUP_EXECUTE GROUP_READ
				WORLD_EXECUTE WORLD_READ)
endif()

=== include/aqsis/CMakeLists.txt ===
project(headers)

# include_install_dir is the base of the header install tree.
set(include_install_dir "${INCLUDEDIR}/aqsis")

add_subdirectory(ri)

#------------------------------------------------------------------------------
# Create generated files and install files from this directory.

# create config.h
include(CheckIncludeFiles)
check_include_files(stdint.h AQSIS_HAVE_STDINT_H)
if(WIN32)
	set(AQSIS_SYSTEM_TYPE "WIN32")
elseif(UNIX)
	set(AQSIS_SYSTEM_TYPE "POSIX")
else()
	message(SEND_ERROR "Unknown platform!")
endif()
set(config_h_name "${PROJECT_BINARY_DIR}/config.h")
configure_file(config.h.in.cmake ${config_h_name})

# Create version.h
set(version_h_name "${PROJECT_BINARY_DIR}/version.h")
configure_file(version.h.in.cmake ${version_h_name})


# Install local headers
set(install_hdrs
	#ribparser.h
	aqsis.h
	inttype.h
	${config_h_name}
	${version_h_name}
)

install(FILES ${install_hdrs} DESTINATION ${include_install_dir} COMPONENT development)

#------------------------------------------------------------------------------

# Install subdirectories of header files.
#install(DIRECTORY math DESTINATION ${include_install_dir} COMPONENT development)
#install(DIRECTORY util DESTINATION ${include_install_dir} COMPONENT development)
#install(DIRECTORY riutil DESTINATION ${include_install_dir} COMPONENT development)
#install(DIRECTORY tex DESTINATION ${include_install_dir} COMPONENT development)

=== libs/core/CMakeLists.txt ===
project(core)

# Check for boost thread.
if(NOT Boost_THREAD_FOUND)
	message(FATAL_ERROR "Aqsis core requires boost thread to build")
endif()

# Generate extra files here.  Extra stuff in this directory is...
add_subproject(api)
add_subproject(ddmanager)
add_subproject(geometry)
add_subproject(raytrace)
add_subproject(texturing_old)

set(core_srcs
	attributes.cpp
	bound.cpp
	bucket.cpp
	bucketprocessor.cpp
	csgtree.cpp
	filters.cpp
	grid.cpp
	imagebuffer.cpp
	imagepixel.cpp
	imagers.cpp
	lights.cpp
	micropolygon.cpp
	mpdump.cpp
	multijitter.cpp
	refcount.cpp
	occlusion.cpp
	optioncache.cpp
	options.cpp
	parameters.cpp
	renderer.cpp
	shaders.cpp
	stats.cpp
	threadscheduler.cpp
	transform.cpp
	${api_srcs}
	${ddmanager_srcs}
	${geometry_srcs}
	${raytrace_srcs}
	${texturing_old_srcs}
)

set(core_test_srcs
	${api_test_srcs}
	occlusion_test.cpp
	bilinear_test.cpp
)

set(core_hdrs
	attributes.h
	bilinear.h
	bound.h
	bucket.h
	bucketprocessor.h
	channelbuffer.h
	clippingvolume.h
	csgtree.h
	forwarddiff.h
	grid.h
	imagebuffer.h
	imagepixel.h
	imagers.h
	isampler.h
	lights.h
	micropolygon.h
	motion.h
	mpdump.h
	multijitter.h
	occlusion.h
	optioncache.h
	options.h
	parameters.h
	plane.h
	renderer.h
	shaders.h
	stats.h
	threadscheduler.h
	transform.h
	${api_hdrs}
	${ddmanager_hdrs}
	${geometry_hdrs}
	${raytrace_hdrs}
	${texturing_old_hdrs}
)

source_group("Header Files" FILES ${core_hdrs})

include_directories(
	${PROJECT_SOURCE_DIR}  #< Needed so that files in subdirectories can find headers.
	${AQSIS_TIFF_INCLUDE_DIR})

# Create list of preprocessor definitions
set(defs AQSIS_RI_EXPORTS AQSIS_CORE_EXPORTS
	"AQSIS_MAIN_CONFIG_NAME=${AQSIS_MAIN_CONFIG_NAME}")
if(AQSIS_ENABLE_MPDUMP)
	list(APPEND defs ENABLE_MPDUMP)
endif()
if(AQSIS_USE_TIMERS)
	list(APPEND defs USE_TIMERS)
endif()
if(AQSIS_ENABLE_THREADING)
	list(APPEND defs ENABLE_THREADING)
endif()
if(DEFAULT_RC_PATH)
	list(APPEND defs "DEFAULT_RC_PATH=${DEFAULT_RC_PATH}")
endif()


# Add library & install
aqsis_add_library(aqsis_core ${core_srcs} ${core_hdrs}
	TEST_SOURCES ${core_test_srcs}
	COMPILE_DEFINITIONS ${defs}
	LINK_LIBRARIES aqsis_math aqsis_riutil aqsis_shadervm
		aqsis_tex aqsis_util aqsis_riutil
		${AQSIS_TIFF_LIBRARIES} ${Boost_THREAD_LIBRARY} ${CARBON_LIBRARY}
	DEPENDS ri_inl
)

aqsis_install_targets(aqsis_core)

=== libs/math/CMakeLists.txt ===
project(math)

set(math_srcs
	cellnoise.cpp
	color.cpp
	lowdiscrep.cpp
	matrix.cpp
	noise.cpp
	noise1234.cpp
	random.cpp
	spline.cpp
)

set(math_test_srcs
	cellnoise_test.cpp
	color_test.cpp
	math_test.cpp
	matrix2d_test.cpp
	matrix_test.cpp
	noise1234_test.cpp
	noise_test.cpp
	spline_test.cpp
	vector2d_test.cpp
	vector3d_test.cpp
	vector4d_test.cpp
)

aqsis_add_library(aqsis_math ${math_srcs} ${math_hdrs}
	TEST_SOURCES ${math_test_srcs}
	COMPILE_DEFINITIONS AQSIS_MATH_EXPORTS
)

aqsis_install_targets(aqsis_math)

=== libs/ri2rib/CMakeLists.txt ===
project(ri2rib)

set(ri2rib_srcs
	../riutil/ri2ricxx.cpp
	../riutil/risyms.cpp
	ri2rib.cpp
)

aqsis_add_library(aqsis_ri2rib ${ri2rib_srcs}
	COMPILE_DEFINITIONS AQSIS_RI_EXPORTS
	LINK_LIBRARIES aqsis_riutil
)

aqsis_install_targets(aqsis_ri2rib)

if(aqsis_enable_testing)
	add_executable(ri2rib_test ri2rib_test.cpp)
	target_link_libraries(ri2rib_test aqsis_ri2rib)
endif()

=== libs/riutil/CMakeLists.txt ===
project(riutil)

# Check for boost iostreams.
if(NOT Boost_IOSTREAMS_FOUND)
	message(FATAL_ERROR "Aqsis riutil requires boost iostreams to build")
endif()

set(riutil_srcs
	framedrop_filter.cpp
	renderutil_filter.cpp
	tee_filter.cpp
	primvartoken.cpp
	ribinputbuffer.cpp
	riblexer.cpp
	ribparser.cpp
	ribtokenizer.cpp
	ribwriter.cpp
	ricxx_filter.cpp
	ricxx_validate.cpp
	tokendictionary.cpp
)

set(riutil_test_srcs
	errorhandler_test.cpp
	primvartoken_test.cpp
	ribinputbuffer_test.cpp
	riblexer_test.cpp
	ribparser_test.cpp
	ribtokenizer_test.cpp
)

set(riutil_hdrs
	errorhandlerimpl.h
	multistringbuffer.h
	ribinputbuffer.h
	riblexer.h
	riblexer_impl.h
	ribparser_impl.h
	ribtoken.h
	ribtokenizer.h
	ricxx2ri.h
	ricxx_cache.h
)
source_group("Header Files" FILES ${riutil_hdrs})

aqsis_add_library(aqsis_riutil ${riutil_srcs} ${riutil_hdrs}
	TEST_SOURCES ${riutil_test_srcs}
	COMPILE_DEFINITIONS AQSIS_RIUTIL_EXPORTS USE_GZIPPED_RIB
	LINK_LIBRARIES aqsis_util ${Boost_IOSTREAMS_LIBRARY} ${AQSIS_ZLIB_LIBRARIES}
)

aqsis_install_targets(aqsis_riutil)

=== libs/shadervm/CMakeLists.txt ===
project(shadervm)

# Check for boost regex.
if(NOT Boost_REGEX_FOUND OR NOT AQSIS_USE_OPENEXR)
	message(FATAL_ERROR "Aqsis shadervm requires boost regex and OpenEXR to build")
endif()

include_directories(${AQSIS_OPENEXR_INCLUDE_DIR} "${AQSIS_OPENEXR_INCLUDE_DIR}/OpenEXR")

set(shadervm_srcs
	dsoshadeops.cpp
	shaderstack.cpp
	shadervm.cpp
	shadervm1.cpp
	shadervm2.cpp
)

set(shadervm_hdrs
	dsoshadeops.h
	idsoshadeops.h
	shadeopmacros.h
	shaderstack.h
	shadervariable.h
	shadervm.h
	shadervm_common.h
)
source_group("Header Files" FILES ${shadervm_hdrs})

add_subproject(shaderexecenv)
include_subproject(pointrender)

set(shadervm_link_libraries aqsis_math aqsis_util aqsis_tex ${Boost_REGEX_LIBRARY} ${pointrender_libs})
if(MINGW)
 list(APPEND shadervm_link_libraries pthread)
endif()


aqsis_add_library(aqsis_shadervm ${shadervm_srcs} ${shadervm_hdrs}
	${shaderexecenv_srcs} ${shaderexecenv_hdrs} ${pointrender_srcs}
	COMPILE_DEFINITIONS AQSIS_SHADERVM_EXPORTS
	LINK_LIBRARIES ${shadervm_link_libraries}
)

aqsis_install_targets(aqsis_shadervm)

=== libs/slcomp/CMakeLists.txt ===
project(slcomp)

add_subproject(parse)
add_subproject(backend)

source_group("Header files" FILES ${parse_hdrs} ${backend_hdrs})

aqsis_add_library(aqsis_slcomp
	${parse_srcs} ${parse_hdrs}
	${backend_srcs} ${backend_hdrs}
	COMPILE_DEFINITIONS AQSIS_SLCOMP_EXPORTS
	LINK_LIBRARIES aqsis_util
)

aqsis_install_targets(aqsis_slcomp)

=== libs/slxargs/CMakeLists.txt ===
project(slxargs)

set(slxargs_srcs
	slo.cpp
	slx.cpp
)

aqsis_add_library(aqsis_slxargs ${slxargs_srcs} ${slxargs_hdrs}
	COMPILE_DEFINITIONS AQSIS_SLXARGS_EXPORTS
	LINK_LIBRARIES aqsis_shadervm
)

aqsis_install_targets(aqsis_slxargs)

=== libs/tex/CMakeLists.txt ===
project(tex)

add_subproject(buffers)
add_subproject(filtering)
add_subproject(io)
add_subproject(maketexture)
add_subproject(pointcloud)

set(tex_srcs ${buffers_srcs} ${filtering_srcs}
	${io_srcs} ${maketexture_srcs} ${pointcloud_srcs}
)
set(tex_test_srcs ${buffers_test_srcs} ${filtering_test_srcs}
	${io_test_srcs} ${maketexture_test_srcs} ${pointcloud_test_srcs}
)

set(tex_hdrs ${buffers_hdrs} ${filtering_hdrs}
	${io_hdrs} ${maketexture_hdrs} ${pointcloud_hdrs}
)
source_group("Header files" FILES ${tex_hdrs})

set(linklibs ${io_linklibs})
if(AQSIS_USE_OPENEXR)
    include_directories(${AQSIS_OPENEXR_INCLUDE_DIR} "${AQSIS_OPENEXR_INCLUDE_DIR}/OpenEXR")
    add_definitions(-DUSE_OPENEXR)
	list(APPEND linklibs ${AQSIS_OPENEXR_LIBRARIES})
endif()
if(AQSIS_USE_PNG)
  include_directories(${AQSIS_PNG_INCLUDE_DIR} ${AQSIS_ZLIB_INCLUDE_DIR})
	add_definitions(-DAQSIS_USE_PNG)
endif()
list(APPEND linklibs ${AQSIS_ZLIB_LIBRARIES})

aqsis_add_library(aqsis_tex ${tex_srcs} ${tex_hdrs}
	TEST_SOURCES ${tex_test_srcs}
	COMPILE_DEFINITIONS AQSIS_TEX_EXPORTS
	LINK_LIBRARIES aqsis_math aqsis_util ${linklibs}
)

aqsis_install_targets(aqsis_tex)

=== debian/changelog ===
aqsis (1.8.2-8) unstable; urgency=medium

  * d/tests/run-aqsis-examples-scenes: fix directory causing tests to fail

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Sat, 01 Jul 2017 00:10:53 +0200

aqsis (1.8.2-7) unstable; urgency=medium

  * Bump Policy Standards-Version to 4.0.0 (no changes needed)
  * Re-enabled Build-Deps on libqt4-dev and libqt4-opengl-dev to build
    again the binaries 'eqsl', 'pisql' and 'ptview'
  * d/patches:
    - add fix-ftbfs-qt4-moc.patch: to make possible to compile binaries
      using Qt4

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Thu, 29 Jun 2017 00:17:05 +0200

aqsis (1.8.2-6) unstable; urgency=medium

  * d/rules: remove unneeded override of dh_auto_build
  * Fixes for 'watch' file to detect the version correctly
  * Add tests for autopkgtest
    - run a simple "--help"
    - render different "features" and "scenes" from the package aqsis-examples

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Mon, 19 Jun 2017 23:13:13 +0200

aqsis (1.8.2-5) unstable; urgency=medium

  * d/control: change "Suggests: aqsis-examples (= ${binary:Version})" for
    "(= ${source:Version})"
  * Switch to debhelper compat level v10
    - Upgrade dependency on debhelper versions
    - Remove "--parallel" in d/rules
  * Update Vcs-* fields for the newest recommended practices

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Mon, 19 Sep 2016 20:41:59 +0200

aqsis (1.8.2-4) unstable; urgency=medium

  * Bump Standards-Version to 3.9.8 (no changes needed)
  * d/patches:
    - Added bug_ftbfs_811840.patch to fix FTBFS with GCC 6 (Closes: #811840)

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Sat, 06 Aug 2016 10:51:33 +0100

aqsis (1.8.2-3) unstable; urgency=medium

  * d/patches:
    - Added 0001-Fix_FTBFS_against_OpenEXR.patch to fix FTBFS with newer
      openexr.  Thanks Mathieu Malaterre.  (Closes: #812519)

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Sun, 31 Jan 2016 00:46:14 +0000

aqsis (1.8.2-2) unstable; urgency=medium

  * Bump Standards-Version to 3.9.6 (no changes needed)
  * Remove from Build-Deps libqt4-dev and libqt4-opengl-dev.  The 'moc'
    preprocessor of Qt 4 cannot cope with syntax of the latest Boost 1.58
    now in unstable, and the upstream project does not contain any fix for
    this or support Qt5 yet.  This disables the binaries 'eqsl', 'pisql'
    and 'ptview'.

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Thu, 27 Aug 2015 19:33:01 +0100

aqsis (1.8.2-1) unstable; urgency=low

  * New upstream release
  * Bump Standards-Version to 3.9.5 (no changes needed)

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Wed, 25 Jun 2014 20:01:58 +0100

=== debian/control ===
Source: aqsis
Section: graphics
Priority: optional
Standards-Version: 4.0.0
Maintainer: Manuel A. Fernandez Montecelo <mafm@debian.org>
Homepage: http://www.aqsis.org/
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/aqsis.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/aqsis.git
Build-Depends: debhelper (>= 10~),
               cmake (>= 2.6.3),
               flex (>= 2.5.35),
               bison (>= 1.35),
               libtiff-dev,
               libjpeg-dev,
               libpng-dev,
               libopenexr-dev,
               libilmbase-dev,
               zlib1g-dev,
               libboost-filesystem-dev (>= 1.42),
               libboost-program-options-dev (>= 1.42),
               libboost-iostreams-dev (>= 1.42),
               libboost-wave-dev (>= 1.42),
               libboost-regex-dev (>= 1.42),
               libboost-serialization-dev (>= 1.42),
               libboost-test-dev (>= 1.42),
               libboost-thread-dev (>= 1.42),
               libqt4-dev (>= 4.6.2),
               libqt4-opengl-dev (>= 4.6.2),
               libtinyxml-dev (>= 2.5),
               xsltproc
Testsuite: autopkgtest

Package: aqsis
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libaqsis1 (= ${binary:Version})
Suggests: aqsis-examples (= ${source:Version})
Description: 3D rendering solution adhering to the RenderMan(R) standard, binaries
 Aqsis is a high quality, photorealistic, 3D rendering solution. It complies
 with the RenderMan(R) interface standard defined by Pixar.
 .
 The RenderMan(R) standard has been used in film and television visual effects
 since its introduction in 1989. Pixar has used their own implementation for all
 of their award winning CG features, and provided their implementation for use
 in the visual effects of most major blockbuster films over the last 2
 decades. The Aqsis project offers a way for individuals and organisations alike
 to gain experience with the RenderMan(R) interface without the cost of
 commercial software licenses.
 .
 This package contains the Aqsis binaries (command line rendering tool, a tool
 for compiling shaders in the RSL language and a tool for preparing textures for
 optimal use).

Package: aqsis-examples
Architecture: all
Depends: ${misc:Depends}
Suggests: aqsis,
          python
Replaces: aqsis-data (<< 1.6.0)
Breaks: aqsis-data (<< 1.6.0)
Description: 3D rendering solution adhering to the RenderMan(R) standard, examples
 Aqsis is a high quality, photorealistic, 3D rendering solution. It complies
 with the RenderMan(R) interface standard defined by Pixar.
 .
 The RenderMan(R) standard has been used in film and television visual effects
 since its introduction in 1989. Pixar has used their own implementation for all
 of their award winning CG features, and provided their implementation for use
 in the visual effects of most major blockbuster films over the last 2
 decades. The Aqsis project offers a way for individuals and organisations alike
 to gain experience with the RenderMan(R) interface without the cost of
 commercial software licenses.
 .
 This package contains examples like scenes, procedurals and shaders.

Package: libaqsis1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Replaces: aqsis-libs (<< 1.6.0),
          aqsis-libsc2a (<< 1.6.0)
Breaks: aqsis-libs (<< 1.6.0),
        aqsis-libsc2a (<< 1.6.0)
Description: 3D rendering solution adhering to the RenderMan(R) standard, shared libs
 Aqsis is a high quality, photorealistic, 3D rendering solution. It complies
 with the RenderMan(R) interface standard defined by Pixar.
 .
 The RenderMan(R) standard has been used in film and television visual effects
 since its introduction in 1989. Pixar has used their own implementation for all
 of their award winning CG features, and provided their implementation for use
 in the visual effects of most major blockbuster films over the last 2
 decades. The Aqsis project offers a way for individuals and organisations alike
 to gain experience with the RenderMan(R) interface without the cost of
 commercial software licenses.
 .
 This package contains the Aqsis shared libraries.

Package: libaqsis-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libaqsis1 (= ${binary:Version})
Replaces: aqsis-libs-dev (<< 1.6.0)
Breaks: aqsis-libs-dev (<< 1.6.0)
Description: 3D rendering solution adhering to the RenderMan(R) standard, development files
 Aqsis is a high quality, photorealistic, 3D rendering solution. It complies
 with the RenderMan(R) interface standard defined by Pixar.
 .
 The RenderMan(R) standard has been used in film and television visual effects
 since its introduction in 1989. Pixar has used their own implementation for all
 of their award winning CG features, and provided their implementation for use
 in the visual effects of most major blockbuster films over the last 2
 decades. The Aqsis project offers a way for individuals and organisations alike
 to gain experience with the RenderMan(R) interface without the cost of
 commercial software licenses.
 .
 This package contains the Aqsis development files.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# CMake doesn't use CPPFLAGS, pass them to CFLAGS/CXXFLAGS instead (bug #662833)
export DEB_BUILD_MAINT_OPTIONS   := hardening=+all
export DEB_CFLAGS_MAINT_APPEND   := -pipe -Wall $(shell dpkg-buildflags --get CPPFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND := -pipe -Wall $(shell dpkg-buildflags --get CPPFLAGS)
export DEB_LDFLAGS_MAINT_APPEND  := -Wl,-Bsymbolic -Wl,--as-needed


AQSIS_CHANGELOG = release-notes/1.8/summary-1.8.0.txt


%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DSYSCONFDIR=/etc/aqsis \
		-DAQSIS_USE_EXTERNAL_TINYXML:BOOL=ON \
		-DAQSIS_USE_PDIFF:BOOL=OFF \
		-DAQSIS_USE_RPATH:BOOL=OFF

override_dh_auto_install:
	dh_auto_install

#	Remove houdini script, not interesting for Debian (it's intended as
#	plugin for 3rd party proprietary software, to use Aqsis as renderer),
#	and also has poor licensing terms (not well explained, not for all
#	files, etc).
	rm -frv debian/tmp/usr/share/aqsis/plugins/houdini

#	Remove empty directory (valid until/unless there are more plugins than
#	houdini), otherwise dh_install fails with --list-missing
	rmdir debian/tmp/usr/share/aqsis/plugins

#	Add exec permissions to several example scripts
	find debian/tmp/usr/ \( -name \*.sh -o -name \*.py \) -exec chmod a+x {} \;

override_dh_installchangelogs:
	dh_installchangelogs $(AQSIS_CHANGELOG)

=== debian/tests/control ===
Tests: run-aqsis-help, run-aqsis-examples-features, run-aqsis-examples-scenes
Depends: aqsis, aqsis-examples
